package edu.sc.seis.darkMagic;

import edu.iris.Fissures.FissuresException;
import edu.iris.Fissures.Time;
import edu.iris.Fissures.IfSeismogramDC.DataCenterCallBack;
import edu.iris.Fissures.IfSeismogramDC.DataCenterOperations;
import edu.iris.Fissures.IfSeismogramDC.DataCenterPOA;
import edu.iris.Fissures.IfSeismogramDC.LocalSeismogram;
import edu.iris.Fissures.IfSeismogramDC.RequestFilter;

public class FluffyDataCenterWrapper extends DataCenterPOA {

    public FluffyDataCenterWrapper(FluffyController wrappedController) throws Exception {
        this.wrapped = (DataCenterOperations)wrappedController.getServant();
        Fluffy.setController(wrappedController);
        fluffy = Fluffy.getFluffy();
    }

    public RequestFilter[] available_data(RequestFilter[] a_filterseq) {
        return wrapped.available_data(fluffy.checkPermission(a_filterseq));
    }

    public void cancel_request(String a_request) throws FissuresException {
        wrapped.cancel_request(a_request);
    }

    public String queue_seismograms(RequestFilter[] a_filterseq)
            throws FissuresException {
        return wrapped.queue_seismograms(fluffy.checkPermission(a_filterseq));
    }

    public String request_seismograms(RequestFilter[] a_filterseq,
                                      DataCenterCallBack a_client,
                                      boolean long_lived,
                                      Time expiration_time)
            throws FissuresException {
        RequestFilter[] permitted = fluffy.checkPermission(a_filterseq);
        return wrapped.request_seismograms(permitted,
                                           a_client,
                                           long_lived,
                                           expiration_time);
    }

    public String request_status(String a_request) throws FissuresException {
        return wrapped.request_status(a_request);
    }

    public LocalSeismogram[] retrieve_queue(String a_request)
            throws FissuresException {
        return wrapped.retrieve_queue(a_request);
    }

    public LocalSeismogram[] retrieve_seismograms(RequestFilter[] a_filterseq)
            throws FissuresException {
        return wrapped.retrieve_seismograms(fluffy.checkPermission(a_filterseq));
    }

    private Fluffy fluffy;

    private DataCenterOperations wrapped;
}
