package edu.sc.seis.darkMagic;

import java.util.ArrayList;
import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.Servant;

import edu.iris.Fissures.Time;
import edu.iris.Fissures.IfNetwork.ChannelId;
import edu.iris.Fissures.IfNetwork.NetworkId;
import edu.iris.Fissures.IfSeismogramDC.DataCenterPOATie;
import edu.iris.Fissures.IfSeismogramDC.RequestFilter;
import edu.iris.Fissures.model.TimeInterval;
import edu.iris.Fissures.model.UnitImpl;
import edu.sc.seis.fissuresUtil.chooser.ClockUtil;

public class MockFluffyController extends FluffyController {

    public MockFluffyController(Properties confProps,
                                String serverPropName,
                                ORB orb) {
        super(confProps, serverPropName, orb);
        wildcardNets = new NetworkId[] {new NetworkId("IU", longAgo),
                                        new NetworkId("II", longAgo),
                                        new NetworkId("US", longAgo),
                                        new NetworkId("XY", longAgo),
                                        new NetworkId("XY", shortAgo),
                                        new NetworkId("XD", longAgo),
                                        new NetworkId("XD", shortAgo)};
    }

    public RequestFilter[] expandNetWildCards(RequestFilter[] filters) {
        ArrayList out = new ArrayList();
        for(int i = 0; i < filters.length; i++) {
            if(filters[i].channel_id.network_id.network_code.equals("*")) {
                for(int j = 0; j < wildcardNets.length; j++) {
                    out.add(new RequestFilter(new ChannelId(wildcardNets[j],
                                                            filters[i].channel_id.station_code,
                                                            filters[i].channel_id.site_code,
                                                            filters[i].channel_id.channel_code,
                                                            filters[i].channel_id.begin_time),
                                              filters[i].start_time,
                                              filters[i].end_time));
                }
            } else {
                out.add(filters[i]);
            }
        }
        return (RequestFilter[])out.toArray(new RequestFilter[0]);
    }

    public Servant getServant() {
        return new DataCenterPOATie(new MockSeismogramDC());
    }

    NetworkId[] wildcardNets;

    Time longAgo = ClockUtil.now()
            .subtract(new TimeInterval(10, UnitImpl.GREGORIAN_YEAR))
            .getFissuresTime();

    Time shortAgo = ClockUtil.now()
            .subtract(new TimeInterval(1, UnitImpl.GREGORIAN_YEAR))
            .getFissuresTime();
}
