package edu.sc.seis.darkMagic;

import edu.iris.Fissures.FissuresException;
import edu.iris.Fissures.Quantity;
import edu.iris.Fissures.Sampling;
import edu.iris.Fissures.Time;
import edu.iris.Fissures.IfParameterMgr.ParameterRef;
import edu.iris.Fissures.IfSeismogramDC.DataCenterCallBack;
import edu.iris.Fissures.IfSeismogramDC.DataCenterOperations;
import edu.iris.Fissures.IfSeismogramDC.LocalSeismogram;
import edu.iris.Fissures.IfSeismogramDC.Property;
import edu.iris.Fissures.IfSeismogramDC.RequestFilter;
import edu.iris.Fissures.model.SamplingImpl;
import edu.iris.Fissures.model.TimeInterval;
import edu.iris.Fissures.model.UnitImpl;
import edu.iris.Fissures.seismogramDC.LocalSeismogramImpl;
import edu.sc.seis.fissuresUtil.chooser.ClockUtil;

public class MockSeismogramDC implements DataCenterOperations {

    public RequestFilter[] available_data(RequestFilter[] a_filterseq) {
        return a_filterseq;
    }

    public void cancel_request(String a_request) throws FissuresException {}

    public String queue_seismograms(RequestFilter[] a_filterseq)
            throws FissuresException {
        throw new FissuresException();
    }

    public String request_seismograms(RequestFilter[] a_filterseq,
                                      DataCenterCallBack a_client,
                                      boolean long_lived,
                                      Time expiration_time)
            throws FissuresException {
        throw new FissuresException();
    }

    public String request_status(String a_request) throws FissuresException {
        throw new FissuresException();
    }

    public LocalSeismogram[] retrieve_queue(String a_request)
            throws FissuresException {
        throw new FissuresException();
    }

    public LocalSeismogram[] retrieve_seismograms(RequestFilter[] a_filterseq)
            throws FissuresException {
        logger.debug("retrieve_seismograms");
        LocalSeismogramImpl[] out = new LocalSeismogramImpl[a_filterseq.length];
        for(int i = 0; i < a_filterseq.length; i++) {
            out[i] = new LocalSeismogramImpl("" + i,
                                             new Property[0],
                                             ClockUtil.now().getFissuresTime(),
                                             2,
                                             new SamplingImpl(1,
                                                              new TimeInterval(1,
                                                                               UnitImpl.SECOND)),
                                             UnitImpl.MICROMETER,
                                             a_filterseq[i].channel_id,
                                             new ParameterRef[0],
                                             new Quantity[0],
                                             new Sampling[0],
                                             new int[] {1, 2});
        }
        return out;
    }

    private static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(MockSeismogramDC.class);
}
